<?php
namespace Datec\DatecFeusermanagement\Validation\Validator;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Pascal Dürsteler <pascal.duersteler@gmail.com>
 *  Extbase is a backport of TYPO3 Flow. All credits go to the TYPO3 Flow team.
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  A copy is found in the textfile GPL.txt and important notices to the license
 *  from the author is found in LICENSE.txt distributed with these scripts.
 *
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Validator for single checkbox to be required
 */
class PasswordValidator extends \TYPO3\CMS\Extbase\Validation\Validator\AbstractValidator {

	/**
	 * Returns TRUE if the given property value is a valid password string.
	 *
	 * If at least one error occurred, the result is FALSE.
	 *
	 * @param mixed $value The value that should be validated
	 * @return boolean TRUE if the value is within the range, otherwise FALSE
	 */
	public function isValid($requestValues) {
		if (!is_object($requestValues)) {
			$value = $requestValues;
		} else {
			$value = $requestValues->getPassword();
		}
		$isValid = TRUE;
		if ($value == "" || strlen($value) < 8) { // at least 8 long
			$this->addError('Ihr Passwort muss mindestens 8 Zeichen lang sein',1221560718);
			$isValid = FALSE;
		}
		if ($value == "" || preg_match('/\d/', $value) == FALSE) { // at least one digit
			$this->addError('Ihr Passwort muss mindestens eine Ziffer enthalten',1221560718);
			$isValid = FALSE;
		}
		if ($value == "" || preg_match('/[A-Z]+/', $value) == FALSE) { // at least one upper case
			$this->addError('Ihr Passwort muss mindestens einen Gro&szlig;buchstaben enthalten',1221560718);
			$isValid = FALSE;
		}
		if ($value == "" || preg_match('/[$^!^%^&^@^?^#]+/', $value) == FALSE) { // at least one symbol
			$this->addError('Ihr Passwort muss mindestens eines dieser Sonderzeichen ($,!,%,&amp;,@,?,#) enthalten',1221560718);
			$isValid = FALSE;
		}
		
		return $isValid;
	}

}

?>