<?php
if (!defined('TYPO3_MODE')) {
	die ('Access denied.');
}

\TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
	'Datec.' . $_EXTKEY,
	'FeUser',
	array(
		'FeUser' => 'actionOverview, myData, registerForm, create, validateRegistration, pwResetRequestForm, pwResetForm, pwUpdate, stop'
	),
	// non-cacheable actions
	array(
		'FeUser' => 'registerForm, myData, create, validateRegistration, pwResetRequestForm, pwResetForm, pwUpdate, stop'
	)
);

// remote auth service
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addService(
	$_EXTKEY, 
	'auth', 
	$_EXTKEY,
	'auth',
	\Datec\DatecFeusermanagement\Services\RemoteAuthenticationService::class,
	array(
		'title' => 'Datec FeUsermanagement Remote Authentication Service',
		'description' => 'Authenticates a user with interation to remote interface',		
		'subtype' => 'getUserFE,authUserFE',		
		'available' => TRUE,
		// tx_svauth_sv1 has 50, t3sec_saltedpw has 70, rsaauth has 60. this must come before
		'priority' => 80,
		'quality' => 80,
		'os' => '',
		'exec' => '',	
		'exec' => '',
		'className' => \Datec\DatecFeusermanagement\Services\RemoteAuthenticationService::class
	)
);

// hash auth service
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addService(
	$_EXTKEY,
	'auth',
	\Datec\DatecFeusermanagement\Services\HashAuthenticationService::class,
	array(
		'title' => 'Datec FeUsermanagement Hash Authentication Service',
		'description' => 'Authenticates a user by hash comparison',
		'subtype' => 'getUserFE,authUserFE',
		'available' => TRUE,
		// tx_svauth_sv1 has 50, t3sec_saltedpw has 70, rsaauth has 60. this must come before
		'priority' => 85,
		'quality' => 80,
		'os' => '',
		'exec' => '',
		'className' => \Datec\DatecFeusermanagement\Services\HashAuthenticationService::class
	)
);

// HOOK
$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['felogin']['postProcContent'][] = 'Datec\DatecFeusermanagement\Hooks\FeLoginHooks->renderDisplayModeLinks';

?>